/*
pot 2 est un programme servant  lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les
termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
ni explicite ni implicite, y compris les garanties de commercialisation ou
d'adaptation dans un but spcifique. Reportez-vous  la Licence Publique
Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr
*/

#include "base.pot.h"

int main(int argc , char *argv[] , char *envp[])
{

/* init des variables */
int c,j;
char salle[50];
char ordi[20];
char talk[2];
char login[9];
char nom[50];
char prenom[50];
char buffer[2];
char *chemin;
struct utmp whereis;
struct passwd* user_info;
int utm;
FILE *sipc;
FILE *samba;
FILE *pot;

/* recueil du chemin de pot.pot et de pot.pot.linux */
chemin = (char *)getenv("HOME");
strcat(chemin,"/.pot.pot");

/* Les arguments */
while ( ( c = getopt(argc,argv,"hltr:") ) != -1 ) 
	switch ( c )
		{
		case 'h' : printf("Ceci est le programme pot version %s\nCe programme a t crit par Fabien Carrion et Guillaume Pinot\nMerci  Remi Verhalle pour son aide\n\tUtilisation :\n- pour savoir si vos amis sont connects, tapez tout simplement pot\n- pour modifier votre liste d\'amis, tapez nedit ~/.pot.pot et tapez un login\npar ligne. Pour ajouter des logins rapidement, vous pouvez aussi tapez :\n\"pot login1 login2...\"\n- Pour retier un login rapidement, taper :\"pot -r login\"\n- tapez pot -h pour afficher ce message\n- tapez pot -l pour voir les logins que vous avez dj enregistr\n- tapez pot -t pour voir les logins que vous avez dj enregistr pour le\nserveur linux (~/.pot.pot.linux)\nhttp://wwwetu.utc.fr/~pinotgui\n",VERSION);
		return 0;
		case 'l' : view(chemin);   return 0;
		case 't' : strcat(chemin,".linux");view(chemin);   return 0;
		case 'r' : suppr(chemin,optarg); return 0;
		default  : printf("Tapez pot -h\n");   return 0;
		}

if ( argc >= 2 )
	{
	if ( *argv[1] != '-')
		{
		pot = fopen(chemin, "a");
		erreur(pot);
		for(j = 0 ; argv[++j] != 0 ; fprintf( pot , "%s\n" , argv[j] ) );
		}
	return 0;
	}

/* Gestion de la liste des connectes */
depart.next = NULL;
depart.previous = NULL;
connecte = &depart;

/* Reprogrammation d'un finger un peu ameliore */
if ( ( utm = open("/var/adm/utmp", 0) ) < 0 )
	{
	fprintf(stderr,"***Warning*** %s\n" , strerror(errno) );
	exit(1);
	}

if ((pot = fopen(chemin, "r")) == NULL )
	{
	fprintf(stderr,"Pot.pot n'existe pas.\nPour plus d'informations tapez : pot -h\n");
	return 15;
	}
while ( read(utm,  (char *)&whereis, sizeof(struct utmp)) == sizeof(struct utmp))
	{
	/* Gain de temps car sur notre reseau tous nos logins ont 8 caractere */
	if (strlen(whereis.ut_name) > 0 )
		{
		user_info=getpwnam(whereis.ut_name);
		if (user_info)
			{
			for ( ; fscanf( pot , "%s" , login ) != EOF ; )
			{
			if ( !strcmp( login , whereis.ut_name ) )
				{
				  if ( strlen(whereis.ut_host) == 0)
				    {strcpy( whereis.ut_host , "console" );}
				kelsal(whereis.ut_host,salle);
				
				if ( !talkable( &whereis ) )
					{
					printf("%s (%s*) est connect(e) %s\n", strtok(user_info->pw_gecos,",") , whereis.ut_name , salle);
					ajoutliste(whereis.ut_name);
					break;
					}
				else
					{
					printf("%s (%s) est connect(e) %s\n", strtok(user_info->pw_gecos,",") , whereis.ut_name , salle);
					ajoutliste(whereis.ut_name);
					break;
					}
				}
			}
			fseek( pot , 0 , SEEK_SET );
			}
		}
	}
fseek( pot , 0 , SEEK_SET );
lseek( utm , 0 , SEEK_SET );

/*lecture de samba*/
samba = popen("/usr/local/samba/bin/smbstatus -b | grep -f $HOME/.pot.pot","r");
erreur(samba);

while ((fscanf(samba,"%s",talk) != EOF) && (fscanf(samba,"%s",login) != EOF) && (fscanf(samba,"%s",ordi) != EOF))
	{
	cherchef(samba," \n" );

	kelsal(ordi,salle);
	
	while ( read(utm,  (char *)&whereis, sizeof(struct utmp)) == sizeof(struct utmp))
	{
	/* Gain de temps car sur notre reseau tous nos logins ont 8 caractere */
	if (strlen(whereis.ut_name) > 7 )
		{
		bcopy( whereis.ut_name , nom , 8);
		nom[8] = 0;
		if (strncmp( nom,login, sizeof(login) ) == 0)
			{
			c = 0;
			break;
			}
		}
	}
	if ( c == 0) continue;
	
	user_info=getpwnam(login);
	if (user_info)
		{
		printf("%s (%s*) est connect(e) sur un PC %s\n", strtok(user_info->pw_gecos,",") , login , salle);
		ajoutliste(login);
		}
	}

fclose(pot);
close(utm);
pclose(samba);

/* lecture de linux */
strcat(chemin,".linux");
if (!(pot = fopen( chemin , "r" )))
	{
	printf("\t pot %s\n",VERSION);
	return 0;
	}
fclose(pot);

sipc = popen("finger @linux | grep -f $HOME","r");
erreur(sipc);

while ((fscanf(sipc,"%s",login) != EOF) && (fscanf(sipc,"%s",prenom) != EOF) && (fscanf(sipc,"%s",nom) != EOF) && (fscanf(sipc,"%s",talk) != EOF))
	{
	strcpy(buffer , "  " );

	while(strcmp(buffer , "(" ) != 0)
		{
		if (buffer[0] == '\r')
			break;
		fgets( buffer , 2 , sipc );}

		if (buffer[0] != '\r')
			{
			fscanf(sipc,"%s",ordi);
			kelsal(ordi,salle);
			}
		else
			strcpy(salle,"dans un endroit inconnu.");

		if(!strncmp(nom,"*",1) || !strncmp(nom,"/",1))
			{
			if (! strncmp(nom,"*",1))
				{
				strcpy(nom,"*");
				printf("%s (%s@linux%s) est connect(e) %s\n", prenom , login , nom , salle);
				}
			else
				printf("%s (%s@linux) est connect(e) %s\n", prenom, login , salle);

			}
		else
			{
			if (! strncmp(talk,"*",1))
				{
				strcpy(talk,"*");
				printf("%s %s (%s@linux%s) est connect(e) %s\n", prenom , nom , login , talk , salle);
				}
			else
				printf("%s %s (%s@linux) est connect(e) %s\n", prenom , nom , login , salle);
			} 

	}
pclose(sipc);

printf("\tpot %s\n",VERSION);

return 0;
}
