#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/types.h>
#include <string.h>
#include <locale.h>
#include <getopt.h>
#include <errno.h>
#include <utmp.h>
#include <pwd.h>
#include <wait.h>
#include <sys/stat.h>

#define TALKABLE	0220		/* tty is writable if 220 mode */
#define VERSION "2.1.1"

struct liste_connecte
{
  char *login;
  char *ordi;
  char *nom;
  struct liste_connecte *next;
  struct liste_connecte *previous;
} *connecte , *precedent , depart;

void kelsal(char *ordi,char *salle);
void erreur(FILE *pipe);
int view(char *chemin);
int suppr(char *chemin,void *optarg);
void cherchef(FILE *pipe,char *caractere);
int talkable( struct utmp *user );
void ajoutliste(char *login);

void kelsal(char *ordi,char *salle)
{

if ( ! strncmp( ordi , "xsme" , 4 ) )
	{
	switch( ordi[4] )
		{
		case '1' : strcpy(salle,"en FB 115.");   break;
		case '0' : strcpy(salle,"en FB 115.");   break;
		case '4' : strcpy(salle," un terminal X du sas A-B.");   break;
		case '6' : strcpy(salle,"en FB 204.");   break;
		case '2' : switch(ordi[5])
			{
			case '3' : strcpy(salle,"au terminal X du Millibar.");   break;
			default : strcpy(salle,"en FB 207.");   break;
			}   break;
		case '5' : strcpy(salle,"en RB 123.");   break;
		case '3' : switch(ordi[5])
			{
			case '0' : ;case '1' : ;case '2' : ;case '3' : ;case '4' : strcpy(salle," un terminal X de FA 200.");   break;
			case '5' : ;case '6' : ;case '7' : ;case '8' : ;case '9' : strcpy(salle," un terminal X de FA 100.");   break;
			}   break;
		case '7' : strcpy(salle,"en FB 207.");   break;
		}
	}
else if ( ! strncmp( ordi , "smep" , 4 ) )
	{
	switch( ordi[5] )
		{
		case 'b' : strcpy(salle,"en FB 113.");   break;
		case 'd' : strcpy(salle,"en FB 114.");   break;
		case 'e' : strcpy(salle,"en FB 108.");   break;
		case 'f' : strcpy(salle,"en FB 104.");   break;
		case 'g' : strcpy(salle,"en FB 101.");   break;
		case 'h' : strcpy(salle,"en FB 209.");   break;
		}
	}
else if ( ! strncmp( ordi , "pcbu" , 4 ) )
	{
	switch( ordi[9] )
		{
		case '4' : strcpy(salle," la BUBF niveau 4");   break;
		case '5' : strcpy(salle," la BUBF niveau 4");   break;
		case 'z' : strcpy(salle," la mezzanine BUBF");   break;
		case 'l' : strcpy(salle," la BU de Royalieu");   break;
		}
	}
else if ( ! strncmp( ordi , "sgix" , 4 ) )
	{
	strcpy(salle," l\'accueil.");
	}
else if ( ! ( strncmp( ordi , "ppp-" , 4 ) && strncmp( ordi , "delt" , 4 ) ) )
	{
	strcpy(salle,"par modem");
	}
else if ( ! ( strncmp( ordi , "pcbd" , 4 ) && strncmp( ordi , "macb" , 4 ) && strncmp( ordi , "ncd38" , 5 ) ) )
	{
	strcpy(salle,"au BDE");
	}
else if ( ! strncmp( ordi , "dmel" , 4 ) )
	{
	strcpy(salle,"au centre de langue.");
	}
else
	{
	strcpy(salle,"dans un endroit inconnu (");
	strcat(salle,ordi);
	strcat(salle,")");
	strcat(salle,".");
	}

}

void erreur(FILE *pipe)
{
if (!pipe)
	{
	fprintf( stderr , "Erreur :%s\n" , strerror(errno));
	exit(13);
	}
}

int view(char *chemin)
{
int n = 0;
char nom[9];
FILE *pot;
pot = fopen(chemin, "r");
erreur(pot);
while(fscanf(pot,"%s",nom) != EOF)
	{
	n++;
	printf("%s\t",nom);
	if (n > 4)
		{
		n = 0;
		printf("\n");
		}
	}
fclose(pot);
printf("\n");
return 0;
}


int suppr(char *chemin,void *optarg)
{
char nom[9];
char chemind[35];

FILE *potd;
FILE *pot = fopen(chemin, "r");

erreur(pot);
strcpy(chemind,chemin);
strcat(chemind,"2");
potd = fopen(chemind, "a+");
erreur(potd);
while(fscanf(pot,"%s",nom) != EOF)
	{
	if( strcmp(nom , optarg) != (int)NULL) 
		{
		fprintf(potd , "%s\n" , nom);
		}
	}
fclose(pot);
fclose(potd);
rename(chemind,chemin);
remove(chemind);
return 0;
}


void cherchef(FILE *pipe,char *caractere)
{
char buffer[2];

strcpy(buffer , "  " );
while(buffer[0] != caractere[0])
	fgets( buffer , 2 , pipe );
}

/* la fonction retourne 1 si on peut communiquer avec le user sinon 0 */
int talkable( struct utmp *user )
{
struct stat ttystatus;
char buf[10];
char buffer[41];

	bcopy(user->ut_line, buf, sizeof(user->ut_line));
	buf[sizeof(user->ut_line)] = 0;
	strcpy( buffer , "/dev/" );
	strcat( buffer , buf );
	buffer[sizeof(user->ut_line)+strlen(buffer)] = 0;
	if (stat(buffer, &ttystatus) < 0)
	{
		fprintf(stderr, "***Warning*** %s\n", strerror(errno));
		exit(4);
	}
if( (ttystatus.st_mode & TALKABLE) == TALKABLE )  return 1;
else return 0;
}

/* la fonction rajoute un connecte */
void ajoutliste(char *login)
{
  while(connecte);
  connecte->next = malloc(sizeof(struct liste_connecte));
  connecte->next->previous = connecte;
  connecte = connecte->next;
  connecte->login = malloc(sizeof(login));
  strcpy(connecte->login,login);
  connecte->next = NULL;
}
